SyntaxElementMorph subclass: #StepElementMorph
	instanceVariableNames: 'expression next oldColor '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements'!

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/9/2009 14:50'!
acceptDroppingMorph: aMorph event: evt

	self next: aMorph! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 22:35'!
addExpression
	expression _ ArgumentElementMorph new.
"	expression color: color muchLighter."
	self addMorphFront: expression.! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/19/2009 22:06'!
addToLast: anElement
	self stack last next: anElement! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/23/2009 02:25'!
asSmalltalk
	expression ifNotNil: [^expression asSmalltalk]! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/9/2009 14:02'!
borderWidth
	^1
! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/27/2009 23:02'!
contextMenu
	|m|
	m _ CustomMenu new.
"	m add: 'duplicate' action: #duplicate. "
	m add: 'delete' action: #throwAway.
	m addLine.
	m add: 'show code...' action: #showGeneratedSmalltalk.
	m add: 'show result...' action: #showResult.
	m add: 'evaluate' action: #evaluate.
	^m! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 20:26'!
drawOn: aCanvas 

	|r bw indent dent bw2 bw3 |
	bw _ self borderWidth.
	bw2 _ bw * 2.
	bw3 _ bw * 3.
	indent _ bw * 5.
	dent _ bw * 5.

	"border"
	"top"
	r _ Rectangle origin: ((self left + bw) @ self top) corner: (self left + indent) @ (self top + bw).
	aCanvas fillRectangle: r color: self borderColorVeryLight.

	r _ Rectangle origin: ((self left + indent - bw) @ (self top + bw)) corner: (self left + indent) @ (self top + bw3).
	aCanvas fillRectangle: r color: self borderColorDark.

	r _ Rectangle origin: ((self left + indent) @ (self top + bw2)) corner: (self left + indent + dent + bw) @ (self top + bw3).
	aCanvas fillRectangle: r color: self borderColorVeryLight.

	r _ Rectangle origin: ((self left + indent + dent) @ (self top)) corner: (self left + indent + dent + bw) @ (self top + bw2).
	aCanvas fillRectangle: r color: self borderColorLight.

	r _ Rectangle origin: ((self left + indent + dent + bw) @ (self top)) corner: (self right) @ (self top + bw).
	aCanvas fillRectangle: r color: self borderColorVeryLight.

	"left"
	r _ Rectangle origin: (self topLeft) corner: (self left + bw) @ (self bottom - bw3).
	aCanvas fillRectangle: r color: self borderColorLight.

	"right"
	r _ Rectangle origin: ((self right - bw) @ (self top + bw)) corner: (self right @ (self bottom - bw2)).
	aCanvas fillRectangle: r color: self borderColorDark.

	"bottom"
	r _ Rectangle origin: (self left @ (self bottom - bw3)) corner: (self left + indent) @ (self bottom - bw2).
	aCanvas fillRectangle: r color: self borderColorVeryDark.

	r _ Rectangle origin: (self left + indent) @ (self bottom - bw3) corner: (self left + indent + bw) @ (self bottom - bw).
	aCanvas fillRectangle: r color: self borderColorLight.

	r _ Rectangle origin: (self left + indent) @ (self bottom - bw) corner: (self left + indent + dent - bw) @ (self bottom).
	aCanvas fillRectangle: r color: self borderColorVeryDark.

	r _ Rectangle origin: (self left + indent + dent - bw) @ (self bottom - bw2) corner: (self left + indent + dent) @ (self bottom).
	aCanvas fillRectangle: r color: self borderColorDark.

	r _ Rectangle origin: (self left + indent + dent - bw) @ (self bottom - bw3) corner: (self right - bw) @ (self bottom - bw2).
	aCanvas fillRectangle: r color: self borderColorVeryDark.

	"body"
"	aCanvas fillRectangle: (Rectangle origin: (self left + bw) @ (self top + bw3) corner: (self right - bw) @ (self bottom - bw3)) color: color."

	aCanvas fillRectangle: (Rectangle origin: (self left + bw) @ (self top + bw3) corner: (self right - bw) @ (self center y - bw)) color: color twiceLighter.

	aCanvas fillRectangle: (Rectangle origin: (self left + bw) @ (self center y - bw) corner: (self right - bw) @ (self center y)) color: color lighter.

	aCanvas fillRectangle: (Rectangle origin: (self left + bw) @ (self center y) corner: (self right - bw) @ (self bottom - bw3)) color: color.


	aCanvas fillRectangle: (Rectangle origin: (self left + bw) @ (self top + bw) corner: (self left + indent - bw) @ (self top + bw3)) color: color twiceLighter.

	aCanvas fillRectangle: (Rectangle origin: (self left + indent + dent + bw) @ (self top + bw) corner: (self right - bw) @ (self top + bw3)) color: color twiceLighter.

	aCanvas fillRectangle: (Rectangle origin: (self left + indent + bw) @ (self bottom - bw3) corner: (self left + indent + dent - bw) @ (self bottom - bw)) color: color.
! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/4/2009 01:44'!
expression
	^expression contents! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/19/2009 22:38'!
expression: anElement
	expression contents: anElement! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/29/2009 22:27'!
fit

	| cw handle bw x y|
	bw _ self borderWidth.
	cw _ self labelFont widthOf: $ .
	handle _ cw * 3.

	self width: expression width  + handle + (bw * 3).
	self height: expression height + (bw * 7).


	x _ self left + bw + handle.
	y _ (bounds center - (expression extent // 2)) y.

	expression position: x @ y.

	next isNil ifFalse:[
		next position: self left @ (self bottom - (self borderWidth * 2))].

	(owner respondsTo: #fit)
		ifTrue: [owner fit]! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 00:16'!
handlesMouseOverDragging: evt
	"Return true if I want to receive mouseEnterDragging: and mouseLeaveDragging: when the hand drags something over me (button up or button down), or when the mouse button is down but there is no mouseDown recipient. The default response is false; subclasses that implement mouse mouseEnterDragging messages should override this to return true."

	"NOTE:  If the hand state matters in these cases, it may be tested by constructs such as
		event anyButtonPressed
		event hand hasSubmorphs"

	^ true
! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 23:14'!
hilite

	oldColor _ color.
	self color: Color white.
	self allOwners do: [:each|
		(each isKindOf: StepElementMorph)
			ifTrue: [each unHilite ]]! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/9/2009 14:40'!
initialize
	super initialize.
	color _ Color lightGreen twiceDarker.
	self addExpression.
	self fit.! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/11/2009 22:50'!
isLast
	^next isNil! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/9/2009 14:02'!
labelFont
	^StrikeFont fontName: 'Verdana' size: 10! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/11/2009 22:51'!
last
	self isLast
		ifTrue: [^self]
		ifFalse: [^next last]! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 00:59'!
mouseEnterDragging: evt
	"Handle a mouseEnterDragging event. The mouse just entered my bounds with a button pressed or laden with submorphs. This default implementation does nothing."

	| m |
	evt hand hasSubmorphs ifFalse: [^self].
	m _ evt hand submorphs first.
	(self wantsDroppedMorph: m event: evt)
		ifTrue: [
			self hilite ].! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 00:40'!
mouseLeaveDragging: evt
	"Handle a mouseLeaveLaden event. The mouse just left my bounds with a button pressed or laden with submorphs. This default implementation does nothing."

	self unHilite! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/11/2009 23:08'!
next
	^next! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 00:42'!
next: anElement
	next _ anElement.
	self addMorphFront: next.
	self fit.
	self unHilite! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/11/2009 23:26'!
removeNext
	| holder |
	next ifNotNil: [next _ nil ].
	holder _ self ownerThatIsA: StepHolderElementMorph.
	holder ifNotNil: [holder fit]! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/30/2009 07:25'!
representsNil

	^self isLast & expression contents isNil! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/11/2009 23:09'!
stack
	| list step |
	list _ OrderedCollection with: self.
	step _ self.
	[step next notNil] whileTrue: [
		step _ step next.
		list add: step ].
	^list
	! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/11/2009 23:21'!
stackExtent
	| w h |
	w _ self width.
	h _ 0.
	self stack do: [:each|
		w _ w max: each width.
		h _ h + each height].
	h _ h - ((self borderWidth * 2) * (self stack size -1)).
	^w@h! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 00:41'!
unHilite

	oldColor ifNotNil: [
		self color: oldColor]! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 20:52'!
wantsDroppedMorph: aMorph event: evt

	^next isNil & (aMorph isKindOf: self class) & (self ownerThatIsA: ElementPaletteMorph) isNil
! !
